int  WF_Init( int argc, char **argv );

void WF_FrameUpdate();

void WF3D_Set_Camera( float fov, float minZ, float maxZ, float x, float y, float z, float pointx, float pointy, float pointz );

void WF3D_Set_FGBG_State( char state );

void WF3D_AttachOject( char *obj1, char *obj2, int moverel, float T1, float T2 );

void WF3D_Define_Object_Begin( char *type_name );

void WF3D_Set_Color( float r, float g, float b, float t );

void WF3D_Add_Triangle( int sides, float vx1, float vy1, float vz1, float vx2, float vy2, float vz2, float vx3, float vy3, float vz3 );

void WF3D_Add_Quad( int sides, float vx1, float vy1, float vz1, float vx2, float vy2, float vz2, 
			float vx3, float vy3, float vz3, float vx4, float vy4, float vz4 );

void WF3D_Change_Object_Scale( float scale );

void WF3D_Set_Scale( float scale );

void WF3D_Change_Object_Offset( float x, float y, float z );

void WF3D_Set_Offset( float x, float y, float z );

void WF3d_Define_Image( char *file_name, float slcx1, float slcy1,  float x1, float y1, float z1, 
                                         float slcx2, float slcy2,  float x2, float y2, float z2, 
                                         float slcx3, float slcy3,  float x3, float y3, float z3, 
                                         float slcx4, float slcy4,  float x4, float y4, float z4 );

void WF3D_Define_Object_End( );

void WF3D_Instantiate_Object( char *name, char *kind, float x, float y, float z, float ax, float ay, float az );

void WF3D_Instantiate_Object_At( char *name, char *kind, float T, float x, float y, float z, float ax, float ay, float az );

void WF3D_Move_Object( char *instance_name, int moverel, float T1, float T2, float x, float y, float z );

void WF3D_Rotate_Object( char *instance_name, int moverel, float T1, float T2, float x, float y, float z );

void WF3D_Orbit_Object( char *instance_name, int moverel, float T1, float T2, float x, float y, float z, char axis, float yang );

void WF3D_ReadFile( char *fname );

float WF3d_TimeQuery();

void WF3D_DrawLine( int relT, float T1, float T2, float r, float g, float b, 
	       float x1, float y1, float z1, float x2, float y2, float z2, float thickness );

void WF3D_BeamXYZ( int relT, float T1, float T2, float r, float g, float b, 
	       float x1, float y1, float z1, float x2, float y2, float z2, float thickness );

void WF3D_Beam_Offset( float offset );

void WF3D_Beam( int moverel, float T1, float T2, char *obj1, char *obj2, float r, float g, float b );

void WF3D_BGcolor( float r, float g, float b );

void WF3D_Def_Text( char *typname, float r, float g, float b, float scale, float thickness, char *text );

struct ObjectInstance *WF3D_Put_Text( char *instname, float r, float g, float b, float scale, float thickness, 
		    float x, float y, float z, float xa, float ya, float za, char *text );

void WF3D_Camera_Move( int moverel, float T1, float T2, float x, float y, float z );

void WF3D_Camera_Point( int moverel, float T1, float T2, float x, float y, float z );

void WF3D_RemoveObject( int moverel, float T, char *name );

void WF3D_RemoveDefinition( int moverel, float T, char *name );

void WF3D_Define_Sphere( char *name, int nhemi, float radius, int nslice, int nlayers, float r, float g, float b, float transp );

void WF3D_Define_Cylinder( char *name, float radius, int nslice, float height, float r, float g, float b, float trans );

void WF3D_Define_Disk( char *name, float radius, int nslice, float r, float g, float b, float trans, 
			int fill, float thick, float ang, float dir );

void WF3D_Define_Box( char *name, float length, float width, float height, float r, float g, float b, float trans );

void WF3D_Scale_Object( char *name, int moverel, float T1, float scaleamount );

void WF3D_Scale_Object_X( char *name, int moverel, float T1, float scaleamount );

void WF3D_Scale_Object_Y( char *name, int moverel, float T1, float scaleamount );

void WF3D_Scale_Object_Z( char *name, int moverel, float T1, float scaleamount );

void WF3D_RemoveBeamList();

void WF3D_ReadFile( char *fname );

void WF3D_Set_Camera_Lens( float fov, float minZ, float maxZ );

void WF3D_Whereis_Object( char *instance_name, float *T, float *x, float *y, float *z );

struct ObjectInstance *WF3D_Display_Time( char *instname, float r, float g, float b, float scale, float thickness, 
                    float x, float y, float z, float xa, float ya, float za, float dt, float tscale, int kind );

void WF_Set_BeamWidth( float beamwidth );

void WF3D_ClearAll();

void WF3D_Camera_Follow_Object( char *name, int moverel, float T1, float offsetx, float offsety, float offsetz );
void WF3D_Camera_UnFollow_Object( int moverel, float T1 );

void WF3D_Camera_UnFollow();

void WF3D_Add_Path_Trace( char *objname, float T_begin, float T_end, float dt, float fade_t, int max_n, int style, 
                     float red, float grn, float blu, float transp, float yoffset );

